/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>CBoolean</b></em>', and utility methods for working with them.
 * <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesPackage#getCBoolean()
 * @model @generated
 */
public final class CBoolean extends AbstractEnumerator {
    /**
     * The '<em><b>True</b></em>' literal value. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #TRUE_LITERAL
     * @model name="true"
     * @generated @ordered
     */
    public static final int TRUE = 0;

    /**
     * The '<em><b>False</b></em>' literal value. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #FALSE_LITERAL
     * @model name="false"
     * @generated @ordered
     */
    public static final int FALSE = 1;

    /**
     * The '<em><b>True</b></em>' literal object. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>True</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #TRUE
     * @generated @ordered
     */
    public static final CBoolean TRUE_LITERAL = new CBoolean(TRUE, "true");

    /**
     * The '<em><b>False</b></em>' literal object. <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>False</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #FALSE
     * @generated @ordered
     */
    public static final CBoolean FALSE_LITERAL = new CBoolean(FALSE, "false");

    /**
     * An array of all the '<em><b>CBoolean</b></em>' enumerators. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final CBoolean[] VALUES_ARRAY = new CBoolean[] { TRUE_LITERAL, FALSE_LITERAL, };

    /**
     * A public read-only list of all the '<em><b>CBoolean</b></em>'
     * enumerators. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>CBoolean</b></em>' literal with the specified
     * name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CBoolean get(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            CBoolean result = VALUES_ARRAY[i];
            if (result.toString().equals(name)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>CBoolean</b></em>' literal with the specified
     * value. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public static CBoolean get(int value) {
        switch (value) {
        case TRUE:
            return TRUE_LITERAL;
        case FALSE:
            return FALSE_LITERAL;
        }
        return null;
    }

    /**
     * Only this class can construct instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private CBoolean(int value, String name) {
        super(value, name);
    }

} //CBoolean
