/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CFunction;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.source.CBlock;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Function</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.impl.CFunctionImpl#getIsVarArg <em>Is Var Arg</em>}
 * </li>
 * <li>{@link com.ibm.etools.c.impl.CFunctionImpl#getSource <em>Source</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CFunctionImpl extends CBehavioralFeatureImpl implements CFunction {
    /**
     * The default value of the '{@link #getIsVarArg() <em>Is Var Arg</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getIsVarArg()
     * @generated @ordered
     */
    protected static final Boolean IS_VAR_ARG_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getIsVarArg() <em>Is Var Arg</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getIsVarArg()
     * @generated @ordered
     */
    protected Boolean isVarArg = IS_VAR_ARG_EDEFAULT;

    /**
     * The cached value of the '{@link #getSource() <em>Source</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSource()
     * @generated @ordered
     */
    protected CBlock source = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CFunctionImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCFunction();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getIsVarArg() {
        return isVarArg;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setIsVarArg(Boolean newIsVarArg) {
        Boolean oldIsVarArg = isVarArg;
        isVarArg = newIsVarArg;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CFUNCTION__IS_VAR_ARG, oldIsVarArg, isVarArg));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBlock getSource() {
        if (source != null && source.eIsProxy()) {
            CBlock oldSource = source;
            source = (CBlock) eResolveProxy((InternalEObject) source);
            if (source != oldSource) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CPackage.CFUNCTION__SOURCE, oldSource, source));
            }
        }
        return source;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBlock basicGetSource() {
        return source;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSource(CBlock newSource) {
        CBlock oldSource = source;
        source = newSource;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CFUNCTION__SOURCE, oldSource, source));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CFUNCTION__PARAMETER:
                return ((InternalEList) getParameter()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CFUNCTION__PARAMETER:
                return ((InternalEList) getParameter()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFUNCTION__NAME:
            return getName();
        case CPackage.CFUNCTION__PARAMETER:
            return getParameter();
        case CPackage.CFUNCTION__IS_VAR_ARG:
            return getIsVarArg();
        case CPackage.CFUNCTION__SOURCE:
            if (resolve)
                return getSource();
            return basicGetSource();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFUNCTION__NAME:
            setName((String) newValue);
            return;
        case CPackage.CFUNCTION__PARAMETER:
            getParameter().clear();
            getParameter().addAll((Collection) newValue);
            return;
        case CPackage.CFUNCTION__IS_VAR_ARG:
            setIsVarArg((Boolean) newValue);
            return;
        case CPackage.CFUNCTION__SOURCE:
            setSource((CBlock) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFUNCTION__NAME:
            setName(NAME_EDEFAULT);
            return;
        case CPackage.CFUNCTION__PARAMETER:
            getParameter().clear();
            return;
        case CPackage.CFUNCTION__IS_VAR_ARG:
            setIsVarArg(IS_VAR_ARG_EDEFAULT);
            return;
        case CPackage.CFUNCTION__SOURCE:
            setSource((CBlock) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFUNCTION__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
        case CPackage.CFUNCTION__PARAMETER:
            return parameter != null && !parameter.isEmpty();
        case CPackage.CFUNCTION__IS_VAR_ARG:
            return IS_VAR_ARG_EDEFAULT == null ? isVarArg != null : !IS_VAR_ARG_EDEFAULT.equals(isVarArg);
        case CPackage.CFUNCTION__SOURCE:
            return source != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (isVarArg: ");
        result.append(isVarArg);
        result.append(')');
        return result.toString();
    }

} //CFunctionImpl
