/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLNumericType.java,v 1.3.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Numeric Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Types of numeric items are: 
 * 	Binary 
 * 	Packed decimal (internal decimal) 
 * 	Zoned decimal (external decimal) 
 * 
 * The PICTURE character-string can contain only the symbols 9, P, S, and V. 
 *  For numeric date fields, the PICTURE character-string can contain only the 
 *  symbols 9 and S. 
 * 
 * Examples of valid ranges 
 *          PICTURE   Valid Range of Values 
 * 
 *            9999     0 through 9999 
 *             S99    -99 through +99 
 *          S999V9    -999.9 through +999.9 
 *          PPP999     0 through .000999 
 *         S999PPP    -1000 through -999000 and 
 *                    +1000 through +999000 or zero 
 * 
 * Other clauses: The USAGE of the item can be DISPLAY, BINARY, 
 *  COMPUTATIONAL, PACKED-DECIMAL, COMPUTATIONAL-3, COMPUTATIONAL-4, or 
 *  COMPUTATIONAL-5. 
 * 
 * Possible usage values for this class are 'binary', 'packedDecimal' and 'display', which are represented by comp-1 and comp-2 declarations, respectively.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getSigned <em>Signed</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getSignLeading <em>Sign Leading</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getSignSeparate <em>Sign Separate</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getTrunc <em>Trunc</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getNumproc <em>Numproc</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getPrecision <em>Precision</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericType#getScale <em>Scale</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType()
 * @model 
 * @generated
 */
public interface COBOLNumericType extends COBOLSimpleType {
	/**
	 * Returns the value of the '<em><b>Signed</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This boolean corresponds to the SIGN clause.  
	 * 
	 * True if number is signed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Signed</em>' attribute.
	 * @see #setSigned(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_Signed()
	 * @model default="true"
	 * @generated
	 */
	Boolean getSigned();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getSigned <em>Signed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Signed</em>' attribute.
	 * @see #getSigned()
	 * @generated
	 */
	void setSigned(Boolean value);

	/**
	 * Returns the value of the '<em><b>Sign Leading</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This attribute corresponds to the LEADING (versus TRAILING) clause.
	 * 
	 * True if LEADING.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sign Leading</em>' attribute.
	 * @see #setSignLeading(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_SignLeading()
	 * @model default="false"
	 * @generated
	 */
	Boolean getSignLeading();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getSignLeading <em>Sign Leading</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sign Leading</em>' attribute.
	 * @see #getSignLeading()
	 * @generated
	 */
	void setSignLeading(Boolean value);

	/**
	 * Returns the value of the '<em><b>Sign Separate</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This boolean corresponds to the SEPARATE clause.
	 * 
	 * True is SEPARATE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sign Separate</em>' attribute.
	 * @see #setSignSeparate(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_SignSeparate()
	 * @model default="false"
	 * @generated
	 */
	Boolean getSignSeparate();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getSignSeparate <em>Sign Separate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sign Separate</em>' attribute.
	 * @see #getSignSeparate()
	 * @generated
	 */
	void setSignSeparate(Boolean value);

	/**
	 * Returns the value of the '<em><b>Trunc</b></em>' attribute.
	 * The literals are from the enumeration {@link com.ibm.etools.cobol.COBOLTruncValue}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trunc</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trunc</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLTruncValue
	 * @see #setTrunc(COBOLTruncValue)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_Trunc()
	 * @model 
	 * @generated
	 */
	COBOLTruncValue getTrunc();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getTrunc <em>Trunc</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trunc</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLTruncValue
	 * @see #getTrunc()
	 * @generated
	 */
	void setTrunc(COBOLTruncValue value);

	/**
	 * Returns the value of the '<em><b>Numproc</b></em>' attribute.
	 * The literals are from the enumeration {@link com.ibm.etools.cobol.COBOLNumprocValue}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Numproc</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Numproc</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLNumprocValue
	 * @see #setNumproc(COBOLNumprocValue)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_Numproc()
	 * @model 
	 * @generated
	 */
	COBOLNumprocValue getNumproc();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getNumproc <em>Numproc</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Numproc</em>' attribute.
	 * @see com.ibm.etools.cobol.COBOLNumprocValue
	 * @see #getNumproc()
	 * @generated
	 */
	void setNumproc(COBOLNumprocValue value);

	/**
	 * Returns the value of the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The number of significant (non-zero) decimal digits in a number
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Precision</em>' attribute.
	 * @see #setPrecision(int)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_Precision()
	 * @model 
	 * @generated
	 */
	int getPrecision();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getPrecision <em>Precision</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Precision</em>' attribute.
	 * @see #getPrecision()
	 * @generated
	 */
	void setPrecision(int value);

	/**
	 * Returns the value of the '<em><b>Scale</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The number of digit positions to the right of the decimal point (can be negative, indicating a scaled integer:  tens, hundreds, etc.)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Scale</em>' attribute.
	 * @see #setScale(int)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericType_Scale()
	 * @model 
	 * @generated
	 */
	int getScale();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericType#getScale <em>Scale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scale</em>' attribute.
	 * @see #getScale()
	 * @generated
	 */
	void setScale(int value);

} // COBOLNumericType
