// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<com.ibm.etools.cobol.preference.ui>>
//   (C) Copyright IBM Corp. 2001,2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************

package com.ibm.etools.cobol.preference.ui.preferencepage;

/**
 * Insert the type's description here.
 * Creation date: (7/27/2001 9:29:28 AM)
 * @author: Administrator
 *
 * Licensed Materials - Property of IBM,
 * WebSphere Studio Workbench
 * (c) Copyright IBM Corp 2000
 */

import org.eclipse.ui.*;
import org.eclipse.jface.preference.*;
import org.eclipse.swt.widgets.*;


import com.ibm.etools.cobol.plugin.CobolPlugin;
import com.ibm.etools.cobol.preference.ui.common.*;

import java.util.*;


/**
 *  The Preference Page
 */
public class CobolPreferencePage extends PreferencePage implements ICobolUIPreferenceConstants, IWorkbenchPreferencePage {
	private static final String copyright = "(c) Copyright IBM Corporation 2001,2004.";


	// static variables
	// plugin.xml .preferencePages page id
	public static final String PLUGIN_PREFERENCEPAGE_ID="com.ibm.etools.cobol.preference.ui.preferencepage.COBOLPreferencePage";

	private CobolPropertiesPage cobolProps;

/**
 * CobolPreferencePage constructor comment.
 */
public CobolPreferencePage( ){
	super();
}

public void init(IWorkbench wb) {
}

/**
 * Insert the method's description here.
 * Creation date: (7/27/2001 10:02:21 AM)
 *
 * Creates preference page controls on demand.
 */
public Control createContents(Composite parent)
{
	cobolProps = new CobolPropertiesPage(this);
	cobolProps.createContents(parent);
	
	// set context help ID
	cobolProps.setHelpContextIds();

//	parent.pack(true);
	return parent;
}

protected IPreferenceStore doGetPreferenceStore() {
	IPreferenceStore store = CobolPlugin.getPlugin().getPreferenceStore();
	return store;
}


/**
 * Insert the method's description here.
 * Creation date: (7/27/2001 10:02:21 AM)
 */
protected void performApply() {

	Vector validationErrors = cobolProps.getValidationErrorMessages();
	if(validationErrors.size() == 0) {
		this.setErrorMessage(null);
		storeValues();
	}
	else {
		this.setErrorMessage((String)validationErrors.elementAt(0));
		if (((String)validationErrors.get(0)).equalsIgnoreCase(com.ibm.etools.cobol.importer.CobolResource.getString("_EXC_Invalid_codepage")))
			cobolProps.getCodePageField().setFocus();
		else
			cobolProps.getTextCurrency().setFocus();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/27/2001 10:02:21 AM)
 */
protected void performDefaults() {
	cobolProps.performDefaults();

}
/**
 * Insert the method's description here.
 * Creation date: (7/27/2001 10:02:21 AM)
 *
 * This is a hook for sublcasses to do special things when the ok
 * button is pressed.
 */
public boolean performOk() {
	Vector validationErrors = cobolProps.getValidationErrorMessages();
	if(validationErrors.size() == 0) {
		storeValues();
	}
	else {
		this.setErrorMessage((String)validationErrors.elementAt(0));
		if (((String)validationErrors.get(0)).equalsIgnoreCase(com.ibm.etools.cobol.importer.CobolResource.getString("_EXC_Invalid_codepage")))
			cobolProps.getCodePageField().setFocus();
		else
			cobolProps.getTextCurrency().setFocus();
		return false;
	}

	return true;
}

/**
 * Insert the method's description here.
 * Creation date: (7/27/2001 10:02:21 AM)
 *
 * Store the values of the controls back to the preference store.
 */
private void storeValues() {
	// store the values
	IPreferenceStore store = this.getPreferenceStore();
	
	HashMap props = cobolProps.getValues();

	Iterator it = props.keySet().iterator();
	
	while (it.hasNext()) {
		String key = (String)it.next();
		if (key.equals(PRE_COBOL_PLATFORM_SELECTION) ||
			key.equals(PRE_COBOL_FLOATING_POINT_FORMAT) ||
			key.equals(PRE_COBOL_ASCII_CODEPAGE) ||
			key.equals(PRE_COBOL_ERROR_MSGS_LANG) ||
			key.equals(PRE_COBOL_COMPILE_TIME_LOCALE)) {
				store.setValue(key, ((Integer)props.get(key)).intValue());
		}
		else if (key.equals(PRE_COBOL_SOSI))
				store.setValue(key, ((Boolean)props.get(key)).booleanValue());
		else
			store.setValue(key, (String)props.get(key));
	}

}

public void validate() {
	//add the code that should react to some widget event
	Vector validationErrors = cobolProps.getValidationErrorMessages();
	if(validationErrors.size() == 0) {
		//storeValues();
		this.setErrorMessage(null);
		setValid(true);
	}
	else {
		this.setErrorMessage((String)validationErrors.elementAt(0));
//		if (((String)validationErrors.get(0)).equalsIgnoreCase(com.ibm.etools.cobol.importer.CobolResource.getString("_EXC_Invalid_codepage")))
//			cobolProps.getCodePageField().setFocus();
//		else
		cobolProps.getTextCurrency().setFocus();
		setValid(false);	
	}	  
}
}